!function(win, doc, nav, libPath, sandbox, scripts, timeout) {
    function ready() {
        if (!sandbox) {
            (sandbox = doc.createElement("iframe")).dataset.partytown = "sandbox";
            sandbox.setAttribute("style", "display:block;width:0;height:0;border:0;visibility:hidden");
            sandbox.setAttribute("aria-hidden", "true");
            sandbox.src = libPath + "partytown-sandbox-sw?" + Date.now();
            doc.body.appendChild(sandbox);
        }
    }
    function fallback(i, script) {
        console.warn("Partytown script fallback");
        sandbox = 1;
        for (i = 0; i < scripts.length; i++) {
            (script = doc.createElement("script")).innerHTML = scripts[i].innerHTML;
            doc.body.appendChild(script);
        }
    }
    libPath = (win.partytown || {}).lib || "/~partytown/";
    libPath += "debug/";
    scripts = doc.querySelectorAll('script[type="text/partytown"]');
    if (location !== parent.location) {
        parent._ptWin(win);
    } else if (scripts.length) {
        if ("serviceWorker" in nav) {
            nav.serviceWorker.register(libPath + "partytown-sw.js", {
                scope: libPath
            }).then((function(swRegistration) {
                swRegistration.active ? ready() : swRegistration.installing ? swRegistration.installing.addEventListener("statechange", (function(ev) {
                    "activated" === ev.target.state && ready();
                })) : console.warn(swRegistration);
            }), (function(e) {
                console.error(e);
            }));
            timeout = setTimeout(fallback, 6e4);
            doc.addEventListener("ptinit", (function() {
                clearTimeout(timeout);
            }));
        } else {
            fallback();
        }
    }
}(window, document, navigator);
